Github messages for voidlinux
 help / color / mirror / Atom feed
From: sgn <sgn@users.noreply.github.com>
To: ml@inbox.vuxu.org
Subject: Re: [PR PATCH] [Updated] lint commits's message
Date: Wed, 19 May 2021 02:44:15 +0200	[thread overview]
Message-ID: <20210519004415.AaIeQtNUy5UlW2UEC0z3SJrL7Cyc0AUCMu9OWeZYGIo@z> (raw)
In-Reply-To: <gh-mailinglist-notifications-41a7ca26-5023-4802-975b-f1789d68868e-void-packages-30950@inbox.vuxu.org>

[-- Attachment #1: Type: text/plain, Size: 1586 bytes --]

There is an updated pull request by sgn against master on the void-packages repository

https://github.com/sgn/void-packages lint-commits
https://github.com/void-linux/void-packages/pull/30950

lint commits's message
<!-- Mark items with [x] where applicable -->

#### General
- [ ] This is a new package and it conforms to the [quality requirements](https://github.com/void-linux/void-packages/blob/master/Manual.md#quality-requirements)

#### Have the results of the proposed changes been tested?
- [ ] I use the packages affected by the proposed changes on a regular basis and confirm this PR works for me
- [ ] I generally don't use the affected packages but briefly tested this PR

<!--
If GitHub CI cannot be used to validate the build result (for example, if the
build is likely to take several hours), make sure to
[skip CI](https://github.com/void-linux/void-packages/blob/master/CONTRIBUTING.md#continuous-integration).
When skipping CI, uncomment and fill out the following section.
Note: for builds that are likely to complete in less than 2 hours, it is not
acceptable to skip CI.
-->
<!-- 
#### Does it build and run successfully? 
(Please choose at least one native build and, if supported, at least one cross build. More are better.)
- [ ] I built this PR locally for my native architecture, (ARCH-LIBC)
- [ ] I built this PR locally for these architectures (if supported. mark crossbuilds):
  - [ ] aarch64-musl
  - [ ] armv7l
  - [ ] armv6l-musl
-->


A patch file from https://github.com/void-linux/void-packages/pull/30950.patch is attached

[-- Warning: decoded text below may be mangled, UTF-8 assumed --]
[-- Attachment #2: github-pr-lint-commits-30950.patch --]
[-- Type: text/x-diff, Size: 2453 bytes --]

From 647ffcdfce88d5314715e60cad5f205819fa2538 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?=C4=90o=C3=A0n=20Tr=E1=BA=A7n=20C=C3=B4ng=20Danh?=
 <congdanhqx@gmail.com>
Date: Mon, 17 May 2021 22:10:52 +0700
Subject: [PATCH] common: add basic commit lint

Warn if:
* subject is longer than 50 characters

Error if:
* any lines are longer than 80 characters except it's footnotes
* second line is not blank
---
 .github/workflows/build.yaml |  1 +
 common/scripts/lint-commits  | 51 ++++++++++++++++++++++++++++++++++++
 2 files changed, 52 insertions(+)
 create mode 100755 common/scripts/lint-commits

diff --git a/.github/workflows/build.yaml b/.github/workflows/build.yaml
index 1ea1da2e4881..011cda3b3ed1 100644
--- a/.github/workflows/build.yaml
+++ b/.github/workflows/build.yaml
@@ -21,6 +21,7 @@ jobs:
       - run: common/travis/changed_templates.sh
       - run: common/travis/fetch-xtools.sh
       - run: common/travis/xlint.sh
+      - run: common/scripts/lint-commits
 
   # Build changed packages.
   build:
diff --git a/common/scripts/lint-commits b/common/scripts/lint-commits
new file mode 100755
index 000000000000..64d96187db89
--- /dev/null
+++ b/common/scripts/lint-commits
@@ -0,0 +1,51 @@
+#!/bin/sh
+
+die() {
+	printf '%s\n' "$*" >&2
+	exit 1
+}
+
+GIT_CMD=$(command -v chroot-git 2>/dev/null) ||
+GIT_CMD=$(command -v git 2>/dev/null) ||
+die "chroot-git and git couldn't be found"
+
+rev_parse() {
+	if [ -n "$1" ]; then
+		"$GIT_CMD" rev-parse --verify "$1"
+	else
+		shift
+		while test "$#" != 0
+		do
+			"$GIT_CMD" rev-parse --verify "$1" 2>/dev/null && return
+			shift
+		done
+		return 1
+	fi
+}
+
+base=$(rev_parse "$1" FETCH_HEAD ORIG_HEAD) || die "base commit not found"
+tip=$(rev_parse "$2" HEAD) || die "tip commit not found"
+status=0
+
+for cmt in $("$GIT_CMD" rev-list --abbrev-commit $base..$tip)
+do
+	"$GIT_CMD" cat-file commit "$cmt" |
+	awk -vC="$cmt" '
+	# skip header
+	/^$/ && !msg { msg = 1; next }
+	!msg { next }
+	# 3: long-line-is-banned-except-footnote-like-this-for-url
+	(NF > 2) && (length > 80) { print C ": long line: " $0; exit 1 }
+	!subject {
+		if (length > 50) { print C ": subject is a bit long" }
+		# Below check is too noisy?
+		# if (!($0 ~ "^New package:" || $0 ~ ".*: update to")) {
+		# 	print C ": not new package/update/removal?"
+		# }
+		subject = 1; next
+	}
+	/^$/ { body = 1; next }
+	!body { print C ": second line must be blank"; exit 1 }
+	' || status=1
+done
+exit $status

  parent reply	other threads:[~2021-05-19  0:44 UTC|newest]

Thread overview: 23+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2021-05-17 15:22 [PR PATCH] " sgn
2021-05-17 15:27 ` [PR PATCH] [Updated] " sgn
2021-05-17 15:28 ` [PR REVIEW] " ericonr
2021-05-17 15:28 ` ericonr
2021-05-17 15:28 ` ericonr
2021-05-17 15:29 ` ericonr
2021-05-17 15:32 ` [PR PATCH] [Updated] " sgn
2021-05-17 15:33 ` [PR REVIEW] " sgn
2021-05-17 15:37 ` sgn
2021-05-17 15:37 ` sgn
2021-05-17 15:42 ` [PR PATCH] [Updated] " sgn
2021-05-17 16:31 ` Duncaen
2021-05-18  5:23 ` sgn
2021-05-18 16:11 ` [PR PATCH] [Updated] " sgn
2021-05-18 16:12 ` [PR REVIEW] " sgn
2021-05-18 16:12 ` sgn
2021-05-19  0:44 ` sgn [this message]
2021-05-19  0:56 ` [PR PATCH] [Updated] " sgn
2021-05-19 16:15 ` [PR REVIEW] " paper42
2021-05-20  0:48 ` sgn
2021-05-20  0:50 ` [PR PATCH] [Updated] " sgn
2021-05-20 16:33 ` sgn
2021-05-21  8:56 ` [PR PATCH] [Merged]: " sgn

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20210519004415.AaIeQtNUy5UlW2UEC0z3SJrL7Cyc0AUCMu9OWeZYGIo@z \
    --to=sgn@users.noreply.github.com \
    --cc=ml@inbox.vuxu.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).